Tests: Reduce runtime for high_throughput_limits test
[lttng-tools.git] / tests / regression / tools / streaming / test_high_throughput_limits
index 7c253ba84755d1ebb2aa44d67dd0e3d85644af26..50c21df4d14cfcdcc8bb62d130dd3eae1bef5e71 100755 (executable)
@@ -1,46 +1,46 @@
 #!/bin/bash
 #
-# Copyright (C) 2012 Christian Babeux <christian.babeux@efficios.com>
-#                      David Goulet <dgoulet@efficios.com>
+# Copyright (C) 2012 Christian Babeux <christian.babeux@efficios.com>
+# Copyright (C) 2012 David Goulet <dgoulet@efficios.com>
 #
-# This library is free software; you can redistribute it and/or modify it under
-# the terms of the GNU Lesser General Public License as published by the Free
-# Software Foundation; version 2.1 of the License.
-#
-# This library is distributed in the hope that it will be useful, but WITHOUT
-# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-# FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
-# details.
-#
-# You should have received a copy of the GNU Lesser General Public License
-# along with this library; if not, write to the Free Software Foundation, Inc.,
-# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA
+# SPDX-License-Identifier: LGPL-2.1-only
 
 TEST_DESC="Streaming - High throughput with bandwidth limits"
 
-CURDIR=$(dirname $0)/
-TESTDIR=$CURDIR/../../..
+# The goal of this test is to try and catch races during tests in conditions
+# where bandwidth is quite limited. It is useful to have enough iterations and
+# apps so that there are dropped events.
+
+CURDIR=$(dirname "$0")/
+TESTDIR="$CURDIR/../../.."
 NR_APP_ITER=10
-NR_ITER=1000000
-BIN_NAME="gen-ust-events"
+NR_ITER=5000
+TESTAPP_PATH="$TESTDIR/utils/testapp"
+TESTAPP_NAME="gen-ust-events"
+TESTAPP_BIN="$TESTAPP_PATH/$TESTAPP_NAME/$TESTAPP_NAME"
 SESSION_NAME="high-throughput"
 EVENT_NAME="tp:tptest"
 SESSIOND_CTRL_PORT=5342
 SESSIOND_DATA_PORT=5343
 DEFAULT_IF="lo"
 
-TRACE_PATH=$(mktemp -d)
+TRACE_PATH=$(mktemp -d -t tmp.test_streaming_high_throughput_limits_trace_path.XXXXXX)
 
-NUM_TESTS=112
+NUM_TESTS=39
 
+# shellcheck source-path=SCRIPTDIR/../../../
 source $TESTDIR/utils/utils.sh
 
-print_test_banner "$TEST_DESC"
-
-if [ ! -x "$CURDIR/$BIN_NAME" ]; then
-       BAIL_OUT "No UST nevents binary detected."
+if [ ! -x "$TESTAPP_BIN" ]; then
+       BAIL_OUT "No UST events binary detected."
 fi
 
+function reset_bw_limit
+{
+       tc qdisc del dev $DEFAULT_IF root >/dev/null 2>&1
+       return $?
+}
+
 function set_bw_limit
 {
        limit=$1
@@ -51,28 +51,41 @@ function set_bw_limit
        # parent qdisc (1:) will always limit us to the right max value
        dataportlimit=$((9*${ctrlportlimit}))
 
+       diag "Set bandwidth limits to ${limit}kbits, ${ctrlportlimit} for control and ${dataportlimit} for data"
 
-       tc qdisc add dev $DEFAULT_IF root handle 1: htb default 15 >/dev/null 2>&1
+       if ! tc qdisc add dev $DEFAULT_IF root handle 1: htb default 15 >/dev/null 2>&1 ; then
+               reset_bw_limit
+               return 1
+       fi
 
        # the total bandwidth is the limit set by the user
-       tc class add dev $DEFAULT_IF parent 1: classid 1:1 htb rate ${limit}kbit ceil ${limit}kbit >/dev/null 2>&1
+       if ! tc class add dev $DEFAULT_IF parent 1: classid 1:1 htb rate ${limit}kbit ceil ${limit}kbit >/dev/null 2>&1 ; then
+               reset_bw_limit
+               return 1
+       fi
        # 1/10 of the bandwidth guaranteed and traffic prioritized for the control port
-       tc class add dev $DEFAULT_IF parent 1:1 classid 1:10 htb rate ${ctrlportlimit}kbit ceil ${limit}kbit prio 1 >/dev/null 2>&1
+       if ! tc class add dev $DEFAULT_IF parent 1:1 classid 1:10 htb rate ${ctrlportlimit}kbit ceil ${limit}kbit prio 1 >/dev/null 2>&1 ; then
+               reset_bw_limit
+               return 1
+       fi
        # 9/10 of the bandwidth guaranteed and can borrow up to the total bandwidth (if unused)
-       tc class add dev $DEFAULT_IF parent 1:1 classid 1:11 htb rate ${dataportlimit}kbit ceil ${limit}kbit prio 2 >/dev/null 2>&1
+       if ! tc class add dev $DEFAULT_IF parent 1:1 classid 1:11 htb rate ${dataportlimit}kbit ceil ${limit}kbit prio 2 >/dev/null 2>&1 ; then
+               reset_bw_limit
+               return 1
+       fi
 
        # filter to assign control traffic to the 1:10 class
-       tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_CTRL_PORT 0xffff flowid 1:10 >/dev/null 2>&1
+       if ! tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_CTRL_PORT 0xffff flowid 1:10 >/dev/null 2>&1 ; then
+               reset_bw_limit
+               return 1
+       fi
        # filter to assign data traffic to the 1:11 class
-       tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_DATA_PORT 0xffff flowid 1:11 >/dev/null 2>&1
-
-       ok $? "Set bandwidth limits to ${limit}kbits, ${ctrlportlimit} for control and ${dataportlimit} for data"
-}
+       if ! tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_DATA_PORT 0xffff flowid 1:11 >/dev/null 2>&1 ; then
+               reset_bw_limit
+               return 1
+       fi
 
-function reset_bw_limit
-{
-       tc qdisc del dev $DEFAULT_IF root >/dev/null 2>&1
-       ok $? "Reset bandwith limits"
+       return 0
 }
 
 function create_lttng_session_with_uri
@@ -80,71 +93,58 @@ function create_lttng_session_with_uri
        sess_name=$1
        uri=$2
        # Create session with custom URI
-       $TESTDIR/../src/bin/lttng/$LTTNG_BIN create -U $uri $sess_name >/dev/null 2>&1
+       "$TESTDIR/../src/bin/lttng/$LTTNG_BIN" create -U "$uri" "$sess_name" >/dev/null 2>&1
        ok $? "Create session with uri $uri"
 }
 
-function enable_lttng_consumer
-{
-       uri=$1
-       # Create session with custom URI
-       $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-consumer -u $uri >/dev/null 2>&1
-       ok $? "Enable consumer with uri $uri"
-}
-
 function run_apps
 {
-       for i in `seq 1 $NR_APP_ITER`; do
+       for i in $(seq 1 $NR_APP_ITER); do
                # With bandwidth limitation, unfortunately, application easily timeout
                # due to very slow communication between the consumer and relayd making
                # the status reply from the consumer quite slow thus delaying the
                # registration done message.
-               LTTNG_UST_REGISTER_TIMEOUT=-1 ./$CURDIR/$BIN_NAME $NR_ITER & >/dev/null 2>&1
-       done
-}
-
-function wait_apps
-{
-       while [ -n "$(pidof $BIN_NAME)" ]; do
-               sleep 1
+               LTTNG_UST_REGISTER_TIMEOUT=-1 $TESTAPP_BIN -i "$NR_ITER" >/dev/null 2>&1 &
        done
-       pass "Wait for applications to end"
 }
 
 function test_high_throughput
 {
        NETWORK_URI="net://localhost"
        create_lttng_session_with_uri $SESSION_NAME $NETWORK_URI
-       enable_lttng_consumer $NETWORK_URI
-       enable_ust_lttng_event $SESSION_NAME $EVENT_NAME
-       start_lttng_tracing $SESSION_NAME
+       enable_ust_lttng_event_ok $SESSION_NAME $EVENT_NAME
+       start_lttng_tracing_ok $SESSION_NAME
        run_apps
-       wait_apps
-       stop_lttng_tracing $SESSION_NAME
-       destroy_lttng_session $SESSION_NAME
+       diag "Waiting for applications to end"
+       wait
+       pass "waiting done"
+       stop_lttng_tracing_ok $SESSION_NAME
+       destroy_lttng_session_ok $SESSION_NAME
        validate_event_count
 }
 
 function validate_event_count
 {
+       TEMP_FILE=$(mktemp -t tmp.streaming_high_throughput_limit_file1.XXXXXX)
+       TEMP_FILE_2=$(mktemp -t tmp.streaming_high_throughput_limit_file2.XXXXXX)
 
-       TEMP_FILE=$(mktemp)
-       TEMP_FILE_2=$(mktemp)
-
-       traced=$(babeltrace $TRACE_PATH 2>/dev/null | wc -l)
-       babeltrace $TRACE_PATH >/dev/null 2>$TEMP_FILE_2
+       traced=$("$BABELTRACE_BIN" "$TRACE_PATH" 2>/dev/null | wc -l)
+       "$BABELTRACE_BIN" "$TRACE_PATH" >/dev/null 2>"$TEMP_FILE_2"
 
-       cat $TEMP_FILE_2 | cut -f4 -d " " >$TEMP_FILE
+       cat "$TEMP_FILE_2" | cut -f4 -d " " >"$TEMP_FILE"
 
        dropped=0
-       while read line;
-       do
-               let dropped=$dropped+$line
-       done < $TEMP_FILE
+       while read -r line; do
+               dropped=$(( dropped + line ))
+       done < "$TEMP_FILE"
 
-       let total=$dropped+$traced
-       let wanted=$NR_APP_ITER*$NR_ITER
+       total=$(( dropped + traced ))
+       wanted=$(( NR_APP_ITER * NR_ITER ))
 
+       if [ $dropped -le 0 ]; then
+               diag "No dropped events during test, consider increasing the number of " \
+                        "apps or iterations"
+       fi
        if [ $wanted -ne $total ]; then
                fail "Validate trace event count"
                diag "Expected $wanted. Dropped $dropped. Recorded $traced. Total $total... "
@@ -153,8 +153,8 @@ function validate_event_count
                pass "Validate trace event count"
                diag "Expected $wanted. Dropped $dropped. Recorded $traced. Total $total... "
 
-               rm -rf $TRACE_PATH
-               rm $TEMP_FILE $TEMP_FILE_2
+               rm -rf "$TRACE_PATH"
+               rm "$TEMP_FILE" "$TEMP_FILE_2"
 
                return 0
        fi
@@ -163,14 +163,17 @@ function validate_event_count
 function interrupt_cleanup()
 {
        diag "*** Exiting ***"
-       stop_lttng_relayd
-       stop_lttng_sessiond
        reset_bw_limit
-       exit 1
+       # invoke utils cleanup
+       full_cleanup
 }
 
 plan_tests $NUM_TESTS
 
+print_test_banner "$TEST_DESC"
+
+bail_out_if_no_babeltrace
+
 if [ "$(id -u)" == "0" ]; then
        isroot=1
 else
@@ -181,20 +184,26 @@ skip $isroot "Root access is needed to set bandwith limits. Skipping all tests."
 {
 
        # Catch sigint and try to cleanup limits
-       trap interrupt_cleanup SIGINT
+       trap interrupt_cleanup SIGTERM SIGINT
 
-       BW_LIMITS=(3200 1600 800 400 200 100 50 25)
-       for BW in ${BW_LIMITS[@]};
+       BW_LIMITS=(3200 400 100)
+       for BW in "${BW_LIMITS[@]}";
        do
                diag "Test high-throughput with bandwidth limit set to ${BW}kbits"
-               set_bw_limit $BW
 
+               set_bw_limit "$BW"
+               ok $? "Setting bandwidth limit"
+
+               # shellcheck disable=SC2119
                start_lttng_sessiond
                start_lttng_relayd "-o $TRACE_PATH"
                test_high_throughput
                result=$?
+               # shellcheck disable=SC2119
                stop_lttng_relayd
+               # shellcheck disable=SC2119
                stop_lttng_sessiond
                reset_bw_limit
+               ok $? "Reset bandwith limits"
        done
 }
This page took 0.026086 seconds and 4 git commands to generate.